/****************************************************************************\

  Copyright 1995 The University of North Carolina at Chapel Hill.
  All Rights Reserved.

  Permission to use, copy, modify and distribute this software and its
  documentation for educational, research and non-profit purposes,
  without fee, and without a written agreement is hereby granted,
  provided that the above copyright notice and the following three
  paragraphs appear in all copies.

  IN NO EVENT SHALL THE UNIVERSITY OF NORTH CAROLINA AT CHAPEL HILL BE
  LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR
  CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE
  USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY
  OF NORTH CAROLINA HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH
  DAMAGES.


  Permission to use, copy, modify and distribute this software and its
  documentation for educational, research and non-profit purposes,
  without fee, and without a written agreement is hereby granted,
  provided that the above copyright notice and the following three
  paragraphs appear in all copies.

  THE UNIVERSITY OF NORTH CAROLINA SPECIFICALLY DISCLAIM ANY
  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE
  PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
  NORTH CAROLINA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
  UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

  The authors may be contacted via:

  US Mail:  Jonathan Cohen                      Amitabh Varshney
            Department of Computer Science      Department of Computer Science 
            Sitterson Hall, CB #3175            State University of New York
            University of N. Carolina           Stony Brook, NY 11794-4400, USA 
            Chapel Hill, NC 27599-3175
	    
  Phone:    (919)962-1749                       Phone: (516)632-8446 
	    
  EMail:    cohenj@cs.unc.edu                   varshney@cs.sunysb.edu

\****************************************************************************/
/*****************************************************************************\
  removal_queue.h
  --
  Description : Data structure and prototypes for the vertex removal queue.

  ----------------------------------------------------------------------------
  $Source: /cvs/RenderPark/SE/Simplify/removal_queue.h,v $
  $Revision: 1.1.1.1 $
  $Date: 2000/04/06 15:35:32 $
  $Author: philippe $
  $Locker:  $
\*****************************************************************************/

/* Protection from multiple includes. */
#ifndef INCLUDED_SIMPLIFY_REMOVAL_QUEUE_H
#define INCLUDED_SIMPLIFY_REMOVAL_QUEUE_H


/*------------------ Includes Needed for Definitions Below ------------------*/


/*-------------------------------- Constants --------------------------------*/


/*--------------------------------- Macros ----------------------------------*/


/*---------------------------------- Types ----------------------------------*/

/* The queue generally "snakes" along in its space as elements are extracted
   from the front and others are added to the end */
typedef struct removal_queue_struct
{
    int   first;
    int   last;
    int   size;
    int   max_size; 
    char *in_queue; /* boolean for each possible queue element (0-max_size)
		       indicating if it's currently in the queue. */
    int  *queue;
} RemovalQueue;

/*---------------------------- Function Prototypes --------------------------*/

void removal_queue_init(RemovalQueue *queue, int size);
void removal_queue_destroy(RemovalQueue *queue);
int removal_queue_extract(RemovalQueue *queue);
void removal_queue_touch(RemovalQueue *queue, int id);

/*---------------------------Globals (externed)------------------------------*/



/* Protection from multiple includes. */
#endif /*INCLUDED_SIMPLIFY_REMOVAL_QUEUE_H*/



/*****************************************************************************\
  $Log: removal_queue.h,v $
  Revision 1.1.1.1  2000/04/06 15:35:32  philippe
  Initial CVS release

  Revision 1.3  1997/04/10 20:10:46  cohenj
  Added Amitabh's name to credits

  Revision 1.2  1996/04/08 19:02:01  cohenj
  added copyright

 * Revision 1.1  95/09/29  19:16:01  cohenj
 * Initial revision
 * 
\*****************************************************************************/

